## milkytracker 1.0.0+dfsg

=== CMakeLists.txt ===
#
#  CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 2.6)
project(MilkyTracker)

# Force SDL if requested
option(FORCESDL "Force SDL instead of native" OFF)
if(FORCESDL)
    unset(APPLE)
    unset(WIN32)
    add_definitions(-D__FORCE_SDL_AUDIO__)
    # Frameworks not supported by findSDL2.cmake
    set(CMAKE_FIND_FRAMEWORK NEVER)
endif()

# Lowercase project name for binaries and packaging
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

# Additional CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

# Version number in format X.YY.ZZ
set(VER_X  1)
set(VER_YY 00)
set(VER_ZZ 00)
set(VER_FULL "${VER_X}.${VER_YY}.${VER_ZZ}")

# Generate version header from the above
configure_file(
    ${PROJECT_SOURCE_DIR}/src/tracker/version.h.in
    ${PROJECT_BINARY_DIR}/src/tracker/version.h
)

# Packaging
if(APPLE)
    set(CPACK_GENERATOR DragNDrop)
    set(CPACK_DMG_VOLUME_NAME "${PROJECT_NAME} ${VER_FULL}")
    set(
        CPACK_DMG_DS_STORE_SETUP_SCRIPT
        ${PROJECT_SOURCE_DIR}/resources/packaging/osx/DMGSetup.scpt
    )
    set(
        CPACK_DMG_BACKGROUND_IMAGE
        ${PROJECT_SOURCE_DIR}/resources/packaging/osx/DMGBackground.tif
    )
elseif(WIN32)
    set(CPACK_GENERATOR ZIP)
else()
    set(CPACK_GENERATOR TGZ)
endif()
set(CPACK_PACKAGE_NAME ${PROJECT_NAME_LOWER})
set(CPACK_PACKAGE_VENDOR "MilkyTracker Team")
set(CPACK_PACKAGE_CONTACT "support@milkytracker.org")
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${VER_FULL}")
set(CPACK_PACKAGE_VERSION_MAJOR ${VER_X})
set(CPACK_PACKAGE_VERSION_MINOR ${VER_YY})
set(CPACK_PACKAGE_VERSION_PATCH ${VER_ZZ})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "FastTracker II compatible music tracker")
include(CPack)

if(APPLE)
    # Set variables for generating the Info.plist file
    set(MACOSX_BUNDLE_BUNDLE_VERSION "${VER_FULL}")
    set(MACOSX_BUNDLE_EXECUTABLE ${PROJECT_NAME})
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "com.Titan.MilkyTracker")
    set(MACOSX_BUNDLE_NSMAIN_NIB_FILE "Application")
    set(MACOSX_BUNDLE_ICON_FILE "carton")
    set(MACOSX_BUNDLE_NAME ${PROJECT_NAME})
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${VER_FULL}")

    # Carbon only required for HIToolbox/Events.h (virtual keycodes)
    find_library(CARBON_LIBRARY Carbon)
    find_library(COCOA_LIBRARY Cocoa)
    find_library(CORE_AUDIO_LIBRARY CoreAudio)
    find_library(CORE_FOUNDATION_LIBRARY CoreFoundation)
    find_library(CORE_MIDI_LIBRARY CoreMIDI)
    find_library(CORE_VIDEO_LIBRARY CoreVideo)
    find_library(OPENGL_LIBRARY OpenGL)

    # OS X MIDI support requires no external libraries
    message(STATUS "Enabled MIDI support (Core MIDI)")
    add_subdirectory(src/midi)
elseif(WIN32)
    # Visual C++ Compiler options
    if(MSVC)
        # Warn if platform toolset may not be targetting Windows XP upwards
        if(NOT ${CMAKE_VS_PLATFORM_TOOLSET} MATCHES "xp")
            message("WARNING:")
            message("Your currently-selected platform toolset may generate")
            message("executables which are incompatible with Windows XP.")
            message("Please set your toolset to be one of v110_xp, v120_xp or")
            message("v140_xp for VS2012, VS2013, and VS2015 respectively.")
            message("You can do so with the '-T' argument to CMake, or by")
            message("entering it in the CMake GUI.")
        endif()

        # Suppress secure string function warnings
        add_definitions(-D_CRT_SECURE_NO_WARNINGS)

        # Enable parallel compilation
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

        # Enable static linkage of the Microsoft Visual C/C++ Runtime
        set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
        set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
        set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MTd")
        set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MT")
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set(
            CMAKE_CXX_FLAGS_RELWITHDEBINFO
            "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MTd"
        )
        set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MT")
    endif()

    # Prevent Windows.h from clashing with the Standard Template Library so we
    # can use std::min/std::max (see https://support.microsoft.com/kb/143208)
    add_definitions(-DNOMINMAX)

    # Windows MIDI support requires no external libraries
    message(STATUS "Enabled MIDI support (WinMM)")
    add_subdirectory(src/midi)
else()
    # Workaround for SDL bug #3295, which we might hit if the distro's SDL2
    # package includes the sdl2-config.cmake file
    # https://bugzilla.libsdl.org/show_bug.cgi?id=3295
    cmake_policy(SET CMP0004 OLD)

    find_package(SDL2 2 REQUIRED)
endif()

# Prefer static linkage under OS X for libraries located with find_package()
if(APPLE)
    set(SUFFIXES_ORIG ${CMAKE_FIND_LIBRARY_SUFFIXES})
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
endif()

# Under Windows we use Git Submodules to locate the decompression libraries
if(UNIX)
    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        find_package(ALSA)

        # Linux MIDI support requires ALSA and RtMidi
        if(ALSA_FOUND)
            find_package(RTMIDI 2.1.0)
            if(RTMIDI_FOUND)
                message(STATUS "Enabled MIDI support (ALSA/RtMidi)")
                add_subdirectory(src/midi)
            else()
                message("MIDI support disabled (RtMidi unavailable)")
            endif()
        else()
            message("MIDI support disabled (ALSA unavailable)")
        endif()
    endif()

    if(NOT APPLE)
        find_package(JACK)
    endif()
    find_package(LHASA)
    find_package(ZLIB)
    find_package(ZZIPLIB)
endif()

# Restore library suffixes
if(APPLE)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ${SUFFIXES_ORIG})
endif()

add_subdirectory(docs)
add_subdirectory(resources/music)
add_subdirectory(src/compression)
add_subdirectory(src/fx)
add_subdirectory(src/milkyplay)
add_subdirectory(src/ppui)
add_subdirectory(src/tracker)

=== docs/CMakeLists.txt ===
#
#  docs/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

set(
    DOCUMENTS
    ChangeLog.html
    FAQ.html
    MilkyTracker.html
    TiTAN.nfo
    ChangeLog.html
)

if(APPLE)
    set(INSTALL_DEST Documentation)
elseif(WIN32)
    list(APPEND DOCUMENTS readme_rtaudio)
    set(INSTALL_DEST .)
else()
    list(APPEND DOCUMENTS readme_unix)
    set(INSTALL_DEST share/doc/${PROJECT_NAME_LOWER})
endif()

install(FILES ${DOCUMENTS} DESTINATION ${INSTALL_DEST})
install(FILES ../AUTHORS DESTINATION ${INSTALL_DEST} RENAME Authors.txt)
install(FILES ../COPYING DESTINATION ${INSTALL_DEST} RENAME Copying.txt)
# add_custom_command(OUTPUT ChangeLog.html COMMAND pandoc ARGS "-so ChangeLog.html ../ChangeLog.md")

=== src/compression/CMakeLists.txt ===
#
#  src/compression/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

set(
    SOURCES
    # AIFFWriter.m
    Decompressor.cpp
    DecompressorLZX.cpp
    DecompressorPP20.cpp
    DecompressorUMX.cpp
    PP20.cpp
    unlzx.cpp
)

set(
    HEADERS
    # AIFFWriter.h
    Decompressor.h
    DecompressorLZX.h
    DecompressorPP20.h
    DecompressorUMX.h
    PP20.h
    unlzx.h
)

# Under Windows, build sources from Git submodules if present
if(WIN32)
    set(LHASA_SUBMODULE_DIR ${PROJECT_SOURCE_DIR}/src/submodules/lhasa)
    set(ZLIB_SUBMODULE_DIR ${PROJECT_SOURCE_DIR}/src/submodules/zlib)
    set(ZZIPLIB_SUBMODULE_DIR ${PROJECT_SOURCE_DIR}/src/submodules/zziplib)

    if(EXISTS ${LHASA_SUBMODULE_DIR}/lib/public/lhasa.h)
        set(LHASA_FOUND ON)
        set(
            LHASA_INCLUDE_DIRS
            ${LHASA_SUBMODULE_DIR}/lib
            ${LHASA_SUBMODULE_DIR}/lib/public
        )
        set(
            LHASA_SOURCES
            ${LHASA_SUBMODULE_DIR}/lib/crc16.c
            ${LHASA_SUBMODULE_DIR}/lib/ext_header.c
            ${LHASA_SUBMODULE_DIR}/lib/lh1_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lh5_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lh6_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lh7_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_arch_unix.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_arch_win32.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_basic_reader.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_endian.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_file_header.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_input_stream.c
            ${LHASA_SUBMODULE_DIR}/lib/lha_reader.c
            ${LHASA_SUBMODULE_DIR}/lib/lhx_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lz5_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/lzs_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/macbinary.c
            ${LHASA_SUBMODULE_DIR}/lib/null_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/pm1_decoder.c
            ${LHASA_SUBMODULE_DIR}/lib/pm2_decoder.c
        )
        set(LHASA_HEADERS
            ${LHASA_SUBMODULE_DIR}/lib/crc16.h
            ${LHASA_SUBMODULE_DIR}/lib/ext_header.h
            ${LHASA_SUBMODULE_DIR}/lib/lha_arch.h
            ${LHASA_SUBMODULE_DIR}/lib/lha_basic_reader.h
            ${LHASA_SUBMODULE_DIR}/lib/lha_decoder.h
            ${LHASA_SUBMODULE_DIR}/lib/lha_endian.h
            ${LHASA_SUBMODULE_DIR}/lib/lha_file_header.h
            ${LHASA_SUBMODULE_DIR}/lib/lha_input_stream.h
            ${LHASA_SUBMODULE_DIR}/lib/macbinary.h
            ${LHASA_SUBMODULE_DIR}/lib/public/lha_decoder.h
            ${LHASA_SUBMODULE_DIR}/lib/public/lha_file_header.h
            ${LHASA_SUBMODULE_DIR}/lib/public/lha_input_stream.h
            ${LHASA_SUBMODULE_DIR}/lib/public/lha_reader.h
            ${LHASA_SUBMODULE_DIR}/lib/public/lhasa.h
        )
        source_group(lhasa FILES ${LHASA_SOURCES} ${LHASA_HEADERS})
        list(APPEND SOURCES ${LHASA_SOURCES})
        list(APPEND HEADERS ${LHASA_HEADERS})
    endif()

    if(EXISTS ${ZLIB_SUBMODULE_DIR}/zlib.h)
        set(ZLIB_FOUND ON)
        set(ZLIB_INCLUDE_DIRS ${ZLIB_SUBMODULE_DIR})
        set(ZLIB_SOURCES
            ${ZLIB_SUBMODULE_DIR}/adler32.c
            ${ZLIB_SUBMODULE_DIR}/compress.c
            ${ZLIB_SUBMODULE_DIR}/crc32.c
            ${ZLIB_SUBMODULE_DIR}/deflate.c
            ${ZLIB_SUBMODULE_DIR}/gzclose.c
            ${ZLIB_SUBMODULE_DIR}/gzlib.c
            ${ZLIB_SUBMODULE_DIR}/gzread.c
            ${ZLIB_SUBMODULE_DIR}/gzwrite.c
            ${ZLIB_SUBMODULE_DIR}/infback.c
            ${ZLIB_SUBMODULE_DIR}/inffast.c
            ${ZLIB_SUBMODULE_DIR}/inflate.c
            ${ZLIB_SUBMODULE_DIR}/inftrees.c
            ${ZLIB_SUBMODULE_DIR}/trees.c
            ${ZLIB_SUBMODULE_DIR}/uncompr.c
            ${ZLIB_SUBMODULE_DIR}/zutil.c
        )
        set(ZLIB_HEADERS
            ${ZLIB_SUBMODULE_DIR}/crc32.h
            ${ZLIB_SUBMODULE_DIR}/deflate.h
            ${ZLIB_SUBMODULE_DIR}/gzguts.h
            ${ZLIB_SUBMODULE_DIR}/inffast.h
            ${ZLIB_SUBMODULE_DIR}/inffixed.h
            ${ZLIB_SUBMODULE_DIR}/inflate.h
            ${ZLIB_SUBMODULE_DIR}/inftrees.h
            ${ZLIB_SUBMODULE_DIR}/trees.h
            ${ZLIB_SUBMODULE_DIR}/zlib.h
            ${ZLIB_SUBMODULE_DIR}/zutil.h
        )
        source_group(zlib FILES ${ZLIB_SOURCES} ${ZLIB_HEADERS})
        list(APPEND SOURCES ${ZLIB_SOURCES})
        list(APPEND HEADERS ${ZLIB_HEADERS})
    endif()

    if(EXISTS ${ZZIPLIB_SUBMODULE_DIR}/zzip/zzip.h)
        set(ZZIPLIB_FOUND ON)
        set(ZZIPLIB_INCLUDE_DIRS ${ZZIPLIB_SUBMODULE_DIR})
        set(ZZIPLIB_SOURCES
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/dir.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/err.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/fetch.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/file.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/fseeko.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/info.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/memdisk.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/mmapped.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/plugin.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/stat.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/write.c
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/zip.c
        )
        set(ZZIPLIB_HEADERS
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/__debug.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/__dirent.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/__fnmatch.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/__hints.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/__mmap.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/_msvc.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/autoconf.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/conf.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/fetch.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/file.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/format.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/fseeko.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/info.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/lib.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/memdisk.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/mmapped.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/plugin.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/stdint.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/types.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/write.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/zzip.h
            ${ZZIPLIB_SUBMODULE_DIR}/zzip/zzip32.h
        )
        source_group(zziplib FILES ${ZZIPLIB_SOURCES} ${ZZIPLIB_HEADERS})
        list(APPEND SOURCES ${ZZIPLIB_SOURCES})
        list(APPEND HEADERS ${ZZIPLIB_HEADERS})
    endif()
endif()

# Optional decompressors
if(LHASA_FOUND)
    message(STATUS "Enabled LHA decompressor")
    list(APPEND SOURCES DecompressorLHA.cpp)
    list(APPEND HEADERS DecompressorLHA.h)
    include_directories(${LHASA_INCLUDE_DIRS})
else()
    message("LHA decompressor disabled (lhasa unavailable)")
endif()

if(ZLIB_FOUND)
    message(STATUS "Enabled GZIP decompressor")
    list(APPEND SOURCES DecompressorGZIP.cpp)
    list(APPEND HEADERS DecompressorGZIP.h)
    include_directories(${ZLIB_INCLUDE_DIRS})
else()
    message("GZIP decompressor disabled (zlib unvailable)")
endif()

if(ZLIB_FOUND AND ZZIPLIB_FOUND)
    message(STATUS "Enabled ZIP decompressor")
    list(APPEND SOURCES DecompressorZIP.cpp ZipExtractor.cpp zziplib/MyIO.cpp)
    list(APPEND HEADERS DecompressorZIP.h ZipExtractor.h zziplib/MyIO.h)
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/compression/zziplib
        ${ZZIPLIB_INCLUDE_DIRS}
    )
else()
    if(NOT ZLIB_FOUND AND NOT ZZIPLIB_FOUND)
        message("ZIP decompressor disabled (zlib and zziplib unavailble)")
    elseif(ZZIPLIB_FOUND)
        message("ZIP decompressor disabled (zlib unvailable)")
    else()
        message("ZIP decompressor disabled (zziplib unvailable)")
    endif()
endif()

# Define this library as an object library; the objects will not be archived
add_library(compression OBJECT ${SOURCES} ${HEADERS})

include_directories(
    ${PROJECT_SOURCE_DIR}/src/milkyplay
    ${PROJECT_SOURCE_DIR}/src/ppui
    ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
)

=== src/midi/CMakeLists.txt ===
#
#  src/midi/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

set(HEADERS
    MidiTools.h
)

# Add platform-specific sources and include paths
if(APPLE)
    set(
        SOURCES
        osx/MidiReceiver_CoreMIDI.mm
    )
    list(
        APPEND HEADERS
        osx/MidiReceiver_CoreMIDI.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
    )
elseif(WIN32)
    set(
        SOURCES
        win32/LongMsg.cpp
        win32/MidiInDevice.cpp
        win32/MidiReceiver_win32.cpp
        win32/ShortMsg.cpp
    )
    list(
        APPEND HEADERS
        win32/LongMsg.h
        win32/MIDIInDevice.h
        win32/MIDIMsg.h
        win32/MidiReceiver_win32.h
        win32/ShortMsg.h
        win32/midi.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/win32
    )
else()
    set(
        SOURCES
        posix/MidiReceiver_pthread.cpp
    )
    list(
        APPEND HEADERS
        posix/MidiReceiver_pthread.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
        ${RTMIDI_INCLUDE_DIR}
    )
endif()

include_directories(
    ${PROJECT_SOURCE_DIR}/src/midi
    ${PROJECT_SOURCE_DIR}/src/milkyplay
    ${PROJECT_SOURCE_DIR}/src/ppui
    ${PROJECT_SOURCE_DIR}/src/ppui/osinterface
    ${PROJECT_SOURCE_DIR}/src/tracker
)

add_library(midi ${SOURCES} ${HEADERS})

if(APPLE)
    target_link_libraries(midi ${CORE_MIDI_LIBRARY})
elseif(WIN32)
    target_link_libraries(midi winmm)
else()
    target_link_libraries(midi ${RTMIDI_LIBRARIES})
endif()

=== src/ppui/CMakeLists.txt ===
#
#  src/ppui/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

add_subdirectory(osinterface)

set(
    SOURCES
    Button.cpp
    CheckBox.cpp
    Container.cpp
    ContextMenu.cpp
    Control.cpp
    DialogBase.cpp
    DialogFileSelector.cpp
    Dictionary.cpp
    DictionaryKey.cpp
    Event.cpp
    Font.cpp
    Graphics_15BIT.cpp
    Graphics_16BIT.cpp
    Graphics_24bpp_generic.cpp
    Graphics_32bpp_generic.cpp
    Graphics_ARGB32.cpp
    Graphics_BGR24.cpp
    Graphics_BGR24_SLOW.cpp
#   Graphics_OGL.cpp
    KeyboardBindingHandler.cpp
    ListBox.cpp
    ListBoxFileBrowser.cpp
    Menu.cpp
    MessageBoxContainer.cpp
    PPUIConfig.cpp
    RadioGroup.cpp
    Screen.cpp
    Scrollbar.cpp
    Seperator.cpp
    Slider.cpp
    StaticText.cpp
    Tools.cpp
    TransparentContainer.cpp
)

set(
    HEADERS
    BasicTypes.h
    Button.h
    CheckBox.h
    Container.h
    ContextMenu.h
    Control.h
    DialogBase.h
    DialogFileSelector.h
    Dictionary.h
    DictionaryKey.h
    DisplayDeviceBase.h
    Event.h
    fastfill.h
    Font.h
    GraphicsAbstract.h
    Graphics.h
#   Graphics_OGL.h
    KeyBindings.h
    KeyboardBindingHandler.h
    ListBoxFileBrowser.h
    ListBox.h
    Menu.h
    MessageBoxContainer.h
    Object.h
    PPPath.h
    PPUIConfig.h
    PPUI.h
    RadioGroup.h
    ScanCodes.h
    Screen.h
    ScrollBar.h
    Seperator.h
    SimpleVector.h
    Singleton.h
    Slider.h
    StaticText.h
    Tools.h
    TransparentContainer.h
    UndoStack.h
    VirtualKeys.h
)

# Add platform-specific sources and include paths
if(APPLE)
    list(APPEND SOURCES cocoa/DisplayDevice_COCOA.mm)
    list(APPEND HEADERS cocoa/DisplayDevice_COCOA.h)
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
        ${PROJECT_SOURCE_DIR}/src/tracker/cocoa
    )
elseif(WIN32)
    list(APPEND SOURCES win32/DisplayDevice_WIN32.cpp)
    list(APPEND HEADERS win32/DisplayDevice_WIN32.h)
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/win32
        ${PROJECT_SOURCE_DIR}/src/milkyplay
    )
else()
    list(APPEND SOURCES
        sdl/DisplayDeviceFB_SDL.cpp
        sdl/DisplayDevice_SDL.cpp
    )
    list(APPEND HEADERS
        sdl/DisplayDeviceFB_SDL.h
        sdl/DisplayDevice_SDL.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
        ${SDL2_INCLUDE_DIRS}
    )
endif()

include_directories(
    ${PROJECT_SOURCE_DIR}/src/ppui
    ${PROJECT_SOURCE_DIR}/src/ppui/osinterface
)

add_library(ppui ${SOURCES} ${HEADERS})

target_link_libraries(
    ppui
    osinterface
)

=== src/tracker/CMakeLists.txt ===
#
#  src/tracker/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

set(
    SOURCES
    AnimatedFXControl.cpp
    ColorExportImport.cpp
    ColorPaletteContainer.cpp
    DialogChannelSelector.cpp
    DialogEQ.cpp
    DialogGroupSelection.cpp
    DialogHandlers.cpp
    DialogListBox.cpp
    DialogPanning.cpp
    DialogQuickChooseInstrument.cpp
    DialogResample.cpp
    DialogWithValues.cpp
    DialogZap.cpp
    EQConstants.cpp
    EditorBase.cpp
    EnvelopeContainer.cpp
    EnvelopeEditor.cpp
    EnvelopeEditorControl.cpp
    Equalizer.cpp
    FileExtProvider.cpp
    FileIdentificator.cpp
    GlobalColorConfig.cpp
    InputControlListener.cpp
    LogoBig.cpp
    LogoSmall.cpp
    ModuleEditor.cpp
    ModuleServices.cpp
    PatternEditor.cpp
    PatternEditorClipBoard.cpp
    PatternEditorControl.cpp
    PatternEditorControlEventListener.cpp
    PatternEditorControlKeyboard.cpp
    PatternEditorControlTransposeHandler.cpp
    PatternEditorTools.cpp
    PatternTools.cpp
    PeakLevelControl.cpp
    Piano.cpp
    PianoControl.cpp
    PlayerController.cpp
    PlayerLogic.cpp
    PlayerMaster.cpp
    RecPosProvider.cpp
    RecorderLogic.cpp
    ResamplerHelper.cpp
    SampleEditor.cpp
    SampleEditorControl.cpp
    SampleEditorControlToolHandler.cpp
    SampleEditorResampler.cpp
    SamplePlayer.cpp
    ScopesControl.cpp
    SectionAbout.cpp
    SectionAbstract.cpp
    SectionAdvancedEdit.cpp
    SectionDiskMenu.cpp
    SectionHDRecorder.cpp
    SectionInstruments.cpp
    SectionOptimize.cpp
    SectionQuickOptions.cpp
    SectionSamples.cpp
    SectionSettings.cpp
    SectionSwitcher.cpp
    SectionTranspose.cpp
    SectionUpperLeft.cpp
    SongLengthEstimator.cpp
    SystemMessage.cpp
    TabHeaderControl.cpp
    TabManager.cpp
    TabTitleProvider.cpp
    TitlePageManager.cpp
    ToolInvokeHelper.cpp
    Tracker.cpp
    TrackerConfig.cpp
    TrackerInit.cpp
    TrackerKeyboard.cpp
    TrackerSettings.cpp
    TrackerSettingsDatabase.cpp
    TrackerShortCuts.cpp
    TrackerShutDown.cpp
    TrackerStartUp.cpp
    TrackerUpdate.cpp
    Undo.cpp
    VRand.cpp
    Zapper.cpp
)

set(
    HEADERS
    ${PROJECT_BINARY_DIR}/src/tracker/version.h
    AnimatedFXControl.h
    ColorExportImport.h
    ColorPaletteContainer.h
    ControlIDs.h
    DialogChannelSelector.h
    DialogEQ.h
    DialogGroupSelection.h
    DialogHandlers.h
    DialogListBox.h
    DialogPanning.h
    DialogQuickChooseInstrument.h
    DialogResample.h
    DialogWithValues.h
    DialogZap.h
    EQConstants.h
    EditModes.h
    EditorBase.h
    EnvelopeContainer.h
    EnvelopeEditor.h
    EnvelopeEditorControl.h
    Equalizer.h
    FileExtProvider.h
    FileIdentificator.h
    FileTypes.h
    FilterParameters.h
    GlobalColorConfig.h
    InputControlListener.h
    LogoBig.h
    LogoSmall.h
    ModuleEditor.h
    ModuleServices.h
    PatternEditor.h
    PatternEditorControl.h
    PatternEditorTools.h
    PatternTools.h
    PeakLevelControl.h
    Piano.h
    PianoControl.h
    PlayerController.h
    PlayerCriticalSection.h
    PlayerLogic.h
    PlayerMaster.h
    RecPosProvider.h
    RecorderLogic.h
    ResamplerHelper.h
    SIPButtons.h
    SampleEditor.h
    SampleEditorControl.h
    SampleEditorControlLastValues.h
    SampleEditorResampler.h
    SamplePlayer.h
    ScopesControl.h
    SectionAbout.h
    SectionAbstract.h
    SectionAdvancedEdit.h
    SectionDiskMenu.h
    SectionHDRecorder.h
    SectionInstruments.h
    SectionOptimize.h
    SectionQuickOptions.h
    SectionSamples.h
    SectionSettings.h
    SectionSwitcher.h
    SectionTranspose.h
    SectionUpperLeft.h
    SongLengthEstimator.h
    SystemMessage.h
    TabHeaderControl.h
    TabManager.h
    TabTitleProvider.h
    TitlePageManager.h
    ToolInvokeHelper.h
    Tracker.h
    TrackerConfig.h
    TrackerSettingsDatabase.h
    Undo.h
    VRand.h
    Zapper.h
)

include_directories(
    # Include the CMake-generated version header from the build directory
    ${PROJECT_BINARY_DIR}/src/tracker
    ${PROJECT_SOURCE_DIR}/src/compression
    ${PROJECT_SOURCE_DIR}/src/fx
    ${PROJECT_SOURCE_DIR}/src/milkyplay
    ${PROJECT_SOURCE_DIR}/src/ppui
    ${PROJECT_SOURCE_DIR}/src/ppui/osinterface
    ${PROJECT_SOURCE_DIR}/src/ppui/sdl
    ${PROJECT_SOURCE_DIR}/src/tracker
)

# Add the compression library.
# The compression library is special in that each decompressor has a constructor
# which statically self-registers the decompressor into a global decompressors
# list. Because they are not each individually referenced in code, the linker
# will discard them if they are archived into a static library. We could work
# around it with compiler-specific flags such as GCC's --whole-archive or
# Clang's --force_load, but instead we use this special CMake feature which lets
# us easily pull in the individual objects without having to manually list them.
list(APPEND SOURCES $<TARGET_OBJECTS:compression>)

# Add platform-specific sources and include paths
if(APPLE)
    # If generating for Xcode, pass in the Interface Builder source as a
    # resource and Xcode will take care of compiling it properly
    if(${CMAKE_GENERATOR} STREQUAL "Xcode")
        set_source_files_properties(
            cocoa/resources/Application.xib
            PROPERTIES
            MACOSX_PACKAGE_LOCATION
            Resources
        )
    endif()

    # Application and document icons
    file(
        GLOB ICONS ${PROJECT_SOURCE_DIR}/resources/pictures/docicons/osx/*.icns
    )
    list(APPEND ICONS ${PROJECT_SOURCE_DIR}/resources/pictures/carton.icns)

    # Ensure icons are copied to the correct bundle location
    set_source_files_properties(
        ${ICONS} PROPERTIES MACOSX_PACKAGE_LOCATION Resources
    )

    list(
        APPEND SOURCES
        ${ICONS}
        cocoa/AppDelegate.mm
        cocoa/MTKeyTranslator.mm
        cocoa/MTTrackerView.mm
        cocoa/main.mm
        cocoa/resources/Application.xib
    )
    list(
        APPEND HEADERS
        cocoa/AppDelegate.h
        cocoa/MTKeyTranslator.h
        cocoa/MTTrackerView.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/midi/osx
        ${PROJECT_SOURCE_DIR}/src/ppui/cocoa
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
        ${PROJECT_SOURCE_DIR}/src/tracker/cocoa
    )
elseif(WIN32)
    list(
        APPEND SOURCES
        win32/PreferencesDialog.cpp
        win32/ThreadTimer.cpp
        win32/Win32_main.cpp
        win32/Win32_resources.rc
    )
    list(
        APPEND HEADERS
        win32/PreferencesDialog.h
        win32/ThreadTimer.h
        win32/Win32_resource.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/midi/win32
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/win32
        ${PROJECT_SOURCE_DIR}/src/ppui/win32
    )
else()
    list(
        APPEND SOURCES
        sdl/SDL_KeyTranslation.cpp
        sdl/SDL_Main.cpp
    )
    list(
        APPEND HEADERS
        sdl/SDL_KeyTranslation.h
    )
    include_directories(
        ${SDL2_INCLUDE_DIRS}
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
    )
endif()

add_definitions(-DMILKYTRACKER)

# Set target names for the executables
if(APPLE OR WIN32)
    # OS X and Windows get a mixed-case binary name
    set(TARGET_NAME ${PROJECT_NAME})
else()
    # Linux/other UNIX get a lower-case binary name
    set(TARGET_NAME ${PROJECT_NAME_LOWER})
endif()

if(APPLE)
    add_executable(${TARGET_NAME} MACOSX_BUNDLE ${SOURCES} ${HEADERS})

    # Xcode can deal with Interface Builder xibs automatically - if we are not
    # generating for Xcode, then we must manually compile and install any xibs
    if(NOT CMAKE_GENERATOR STREQUAL "Xcode")
        # Locate ibtool
        find_program(IBTOOL ibtool HINTS /usr/bin ${OSX_DEVELOPER_ROOT}/usr/bin)
        if(IBTOOL STREQUAL "IBTOOL-NOTFOUND")
            message(SEND_ERROR "Unable to find ibtool. Is Xcode installed?")
        endif()

        # The Interface Builder xib file to be compiled
        set(
            XIB_FILE
            ${PROJECT_SOURCE_DIR}/src/tracker/cocoa/resources/Application.xib
        )

        # Destination for compiled xib
        set(RESOURCES_DIR $<TARGET_FILE_DIR:${TARGET_NAME}>/../Resources)

        # Ensure the destination directory of the compiled xib exists
        add_custom_command(
            TARGET ${TARGET_NAME} PRE_BUILD COMMAND mkdir -p ${RESOURCES_DIR}
        )

        # Compile the xib file
        add_custom_command(
            TARGET ${TARGET_NAME} POST_BUILD COMMAND ${IBTOOL} --errors
            --warnings --notices --output-format human-readable-text --compile
            ${RESOURCES_DIR}/${MACOSX_BUNDLE_NSMAIN_NIB_FILE}.nib ${XIB_FILE}
            COMMENT "Compiling ${XIB_FILE}"
        )
    endif()

    # Pass in the Info.plist template, whose variables are defined in the
    # top-level CMakeLists.txt
    set_target_properties(
        ${TARGET_NAME}
        PROPERTIES
        MACOSX_BUNDLE_INFO_PLIST
        ${PROJECT_SOURCE_DIR}/src/tracker/cocoa/resources/Info.plist.in
    )

    # Enable ARC (automatic reference counting) for OS X build
    set_property(
        TARGET ${TARGET_NAME} APPEND_STRING PROPERTY COMPILE_FLAGS "-fobjc-arc"
    )

    target_link_libraries(
        ${TARGET_NAME}
        midi
        ${CORE_VIDEO_LIBRARY}
        ${OPENGL_LIBRARY}
    )
elseif(WIN32)
    add_executable(${TARGET_NAME} WIN32 ${SOURCES} ${HEADERS})

    target_link_libraries(${TARGET_NAME} midi)
else()
    add_executable(${TARGET_NAME} ${SOURCES} ${HEADERS})

    target_link_libraries(${TARGET_NAME} ${SDL2_LIBRARIES})

    if(ALSA_FOUND AND RTMIDI_FOUND)
        add_definitions(-DHAVE_LIBASOUND)
        target_link_libraries(${TARGET_NAME} midi ${RTMIDI_LIBRARIES})
    endif()
endif()

if(UNIX)
    if(ZLIB_FOUND)
        target_link_libraries(${TARGET_NAME} ${ZLIB_LIBRARIES})
    endif()

    if(ZZIPLIB_FOUND)
        target_link_libraries(${TARGET_NAME} ${ZZIPLIB_LIBRARIES})
    endif()

    if(LHASA_FOUND)
        target_link_libraries(${TARGET_NAME} ${LHASA_LIBRARIES})
    endif()
endif()

target_link_libraries(
    ${TARGET_NAME}
    fx
    milkyplay
    osinterface
    ppui
)

# OS X and Windows install to the root of the prefix, the others install to bin
if(APPLE OR WIN32)
    set(INSTALL_DEST .)
else()
    set(INSTALL_DEST bin)
endif()

install(TARGETS ${TARGET_NAME} DESTINATION ${INSTALL_DEST})

=== src/ppui/osinterface/CMakeLists.txt ===
#
#  src/ppui/osinterface/CMakeLists.txt
#
#  Copyright 2016 Dale Whinham
#
#  This file is part of MilkyTracker.
#
#  MilkyTracker is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  MilkyTracker is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
#

set(
    SOURCES
    PPPathFactory.cpp
)

set(
    HEADERS
    PPMessageBox.h
    PPModalDialog.h
    PPOpenPanel.h
    PPPathFactory.h
    PPQuitSaveAlert.h
    PPSavePanel.h
    PPSystem.h
)

# Add platform-specific sources and include paths
if(APPLE)
    list(APPEND SOURCES
        cocoa/PPMessageBox_COCOA.mm
        cocoa/PPOpenPanel_COCOA.mm
        cocoa/PPQuitSaveAlert_COCOA.mm
        cocoa/PPSavePanel_COCOA.mm
        posix/PPMutex.cpp
        posix/PPPath_POSIX.cpp
        posix/PPSystem_POSIX.cpp
    )
    list(APPEND HEADERS
        posix/PPMutex.h
        posix/PPPath_POSIX.h
        posix/PPSystemString_POSIX.h
        posix/PPSystem_POSIX.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
    )
elseif(WIN32)
    list(APPEND SOURCES
        win32/PPMessageBox_WIN32.cpp
        win32/PPMutex.cpp
        win32/PPOpenPanel_WIN32.cpp
        win32/PPPath_WIN32.cpp
        win32/PPQuitSaveAlert_WIN32.cpp
        win32/PPSavePanel_WIN32.cpp
        win32/PPSystem_WIN32.cpp
        win32/WaitWindow_WIN32.cpp
    )
    list(APPEND HEADERS
        win32/PPMutex.h
        win32/PPPath_WIN32.h
        win32/PPSystemString_WIN32.h
        win32/PPSystem_WIN32.h
        win32/WaitWindow_WIN32.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/milkyplay
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/win32
    )
else()
    list(APPEND SOURCES
        posix/PPPath_POSIX.cpp
        posix/PPSystem_POSIX.cpp
        sdl/PPMessageBox_SDL.cpp
        sdl/PPMutex.cpp
        sdl/PPOpenPanel_SDL.cpp
        sdl/PPQuitSaveAlert_SDL.cpp
        sdl/PPSavePanel_SDL.cpp
        sdl/SDL_ModalLoop.cpp
    )
    list(APPEND HEADERS
        posix/PPMutex.h
        posix/PPPath_POSIX.h
        posix/PPSystemString_POSIX.h
        posix/PPSystem_POSIX.h
        sdl/PPMutex.h
        sdl/SDL_ModalLoop.h
    )
    include_directories(
        ${PROJECT_SOURCE_DIR}/src/ppui/osinterface/posix
        ${SDL2_INCLUDE_DIRS}
    )
endif()

include_directories(
    ${PROJECT_SOURCE_DIR}/src/ppui
    ${PROJECT_SOURCE_DIR}/src/ppui/osinterface
)

add_library(osinterface ${SOURCES} ${HEADERS})

=== debian/changelog ===
milkytracker (1.0.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

  * debian/control:
    - Change Gürkan's surname to Myczko (at his request).
    - Bump standards to 4.0.0 (no changes required).

 -- James Cowgill <jcowgill@debian.org>  Sun, 18 Jun 2017 22:29:52 +0100

milkytracker (1.0.0+dfsg-1) experimental; urgency=medium

  * New upstream version.
    - Fixes FTBFS with GCC 7. (Closes: #853551)

  * debian/control:
    - Update new homepage.
    - Update various build dependencies for 1.0.0.
  * debian/compat:
    - Use debhelper compat 10.
  * debian/copyright:
    - Update copyright information for 1.0.0.
    - Exclude non-free music samples from source tarball.
  * debian/patches:
    - Drop all existing patches (obsolete in 1.0.0).
    - Add patch to prevent installing non-free music samples.

 -- James Cowgill <jcowgill@debian.org>  Thu, 13 Apr 2017 23:43:29 +0100

=== debian/control ===
Source: milkytracker
Section: sound
Priority: optional
Maintainer: Debian Multimedia Team <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Gürkan Myczko <gurkan@phys.ethz.ch>,
 James Cowgill <jcowgill@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 dh-exec,
 libasound2-dev [linux-any],
 liblhasa-dev,
 libsdl2-dev,
 libjack-dev,
 librtmidi-dev [linux-any],
 libzzip-dev,
 zlib1g-dev
Homepage: http://milkytracker.titandemo.org/
Standards-Version: 4.0.0
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/milkytracker.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/milkytracker.git

Package: milkytracker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: freepats, opencubicplayer, xmp, schism, goattracker
Description: music creation tool inspired by Fast Tracker 2
 This is an editor for "tracked" music, i.e. audio samples of instruments
 pitch shifted according to the note data.
 .
 It can load the following module formats: 669, AMS, AMF, DBM, CBA, DIGI,
 DSM, FAR, GMC, GDM, IMF, IT, MOD, MDL, MTM, MXM, OKT, PLM, PSM, PTM, S3M,
 STM, ULT, UNI, and X.
 .
 Export is possible into the formats: XM, MOD, and WAV.
 .
 Supported sample and instrument formats: WAV, IFF/XI, PAT

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	rm $(CURDIR)/debian/milkytracker/usr/share/doc/milkytracker/Copying.txt

## milkytracker 1.01.00+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,11 @@
 #  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
 #
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.5)
 project(MilkyTracker)
+
+# Adhere to GNU filesystem layout conventions
+include(GNUInstallDirs)
 
 # Force SDL if requested
 option(FORCESDL "Force SDL instead of native" OFF)
@@ -40,7 +43,7 @@
 
 # Version number in format X.YY.ZZ
 set(VER_X  1)
-set(VER_YY 00)
+set(VER_YY 01)
 set(VER_ZZ 00)
 set(VER_FULL "${VER_X}.${VER_YY}.${VER_ZZ}")
 
@@ -78,6 +81,17 @@
 include(CPack)
 
 if(APPLE)
+    # Warn if deployment target isn't set to Lion
+    if(NOT CMAKE_OSX_DEPLOYMENT_TARGET MATCHES "10.7")
+        message(WARNING
+            "Your deployment target is either unset or not set to \"10.7\", "
+            "which means that the binaries produced may not run on earlier "
+            "versions of macOS.\n"
+            "Please re-run CMake with '-DCMAKE_OSX_DEPLOYMENT_TARGET=10.7' "
+            "or change the variable in the CMake GUI to target Lion and newer."
+        )
+    endif()
+
     # Set variables for generating the Info.plist file
     set(MACOSX_BUNDLE_BUNDLE_VERSION "${VER_FULL}")
     set(MACOSX_BUNDLE_EXECUTABLE ${PROJECT_NAME})
@@ -103,14 +117,15 @@
     # Visual C++ Compiler options
     if(MSVC)
         # Warn if platform toolset may not be targetting Windows XP upwards
-        if(NOT ${CMAKE_VS_PLATFORM_TOOLSET} MATCHES "xp")
-            message("WARNING:")
-            message("Your currently-selected platform toolset may generate")
-            message("executables which are incompatible with Windows XP.")
-            message("Please set your toolset to be one of v110_xp, v120_xp or")
-            message("v140_xp for VS2012, VS2013, and VS2015 respectively.")
-            message("You can do so with the '-T' argument to CMake, or by")
-            message("entering it in the CMake GUI.")
+        if(NOT CMAKE_VS_PLATFORM_TOOLSET MATCHES "xp")
+            message(WARNING
+                "Your currently-selected platform toolset may generate "
+                "executables which are incompatible with Windows XP.\n"
+                "Please set your toolset to be one of v110_xp, v120_xp or "
+                "v140_xp for VS2012, VS2013, and VS2015 respectively.\n"
+                "You can do so with the '-T' argument to CMake, or by entering "
+                "it in the CMake GUI."
+            )
         endif()
 
         # Suppress secure string function warnings
@@ -156,10 +171,21 @@
     set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
 endif()
 
-# Under Windows we use Git Submodules to locate the decompression libraries
+# Under macOS and Windows we use Git Submodules to locate the decompression libs
 if(UNIX)
+    # zlib is provided by Linux and macOS
+    find_package(ZLIB)
+
+    # We can't use Brew for these due to OSX target version mismatch
+    # (we're targeting an older version of OSX to increase compatibility)
+    if(!APPLE)
+      find_package(LHASA)
+      find_package(ZZIPLIB)
+    endif()
+
     if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
         find_package(ALSA)
+        find_package(JACK)
 
         # Linux MIDI support requires ALSA and RtMidi
         if(ALSA_FOUND)
@@ -174,13 +200,6 @@
             message("MIDI support disabled (ALSA unavailable)")
         endif()
     endif()
-
-    if(NOT APPLE)
-        find_package(JACK)
-    endif()
-    find_package(LHASA)
-    find_package(ZLIB)
-    find_package(ZZIPLIB)
 endif()
 
 # Restore library suffixes

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
     set(INSTALL_DEST .)
 else()
     list(APPEND DOCUMENTS readme_unix)
-    set(INSTALL_DEST share/doc/${PROJECT_NAME_LOWER})
+    set(INSTALL_DEST ${CMAKE_INSTALL_DOCDIR})
 endif()
 
 install(FILES ${DOCUMENTS} DESTINATION ${INSTALL_DEST})

=== debian/changelog ===
milkytracker (1.01.00+dfsg-1build1) bionic; urgency=medium

  * No-change rebuild against librtmidi4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 05 Nov 2017 06:45:11 +0000

milkytracker (1.01.00+dfsg-1) unstable; urgency=medium

  * New upstream version.

  * debian/copyright:
    - Move apple-permissive license to the bottom.
    - Update for 1.01.
  * debian/patches:
    - Refresh.
    - Add upstream patch to fix lhasa, zziplib detection.
  * debian/rules:
    - Install documentation into lowercase doc dir.

 -- James Cowgill <jcowgill@debian.org>  Mon, 31 Jul 2017 11:26:28 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: milkytracker
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Team <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Team <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Gürkan Myczko <gurkan@phys.ethz.ch>,
  James Cowgill <jcowgill@debian.org>
